; Break out - by Werner Albus - www.nachtoptik.de - v1.04

; Load your own 3 pieces "Beep" Sound Files for Sound ! - if you want sound

Global timer_event_1, stepp, stepp_1, go_x, go_y

animation_speed=10 ; i think, good so for the moostly Computers - Handbrake for very quickly Computers :-)

; ------------------------------- User editable Parameters -------------------------------
stepp_0=5       ; Speed - Start Default value - from 1 available up to max Levels ( ~20 )
max_levels=12   ; Maximal Levels - Ball Speed add automaticaly from Level to Level
max_balls=5     ; Amount Balls in each Level
racket_width=60 ; Racket width
win_y=700       ; Window Y - resizable
; -----------------------------------------------------------------------------------------

win_x=1200      ; Window X
stepp_1=stepp_0
ball_x=0
ball_y=200
clinker=149
max_balls_1=max_balls*15

If InitMouse() = 0
  MessageRequester("Error", "Can not init Mouse",0)
  End
EndIf

; If InitSound() = 0
;   MessageRequester("Error", "Can not init Sound",0)
;   End
; EndIf

; DataSection
;   beep_0:
;   IncludeBinary"beep_0.wav" ; Beep Sound File 0
;   beep_1:
;   IncludeBinary"beep_1.wav" ; Beep Sound File 1
;   beep_2:
;   IncludeBinary"beep_2.wav" ; Beep Sound File 2
; EndDataSection

; CatchSound(0,?beep_0)
; CatchSound(1,?beep_1)
; CatchSound(2,?beep_2)

Procedure timer_events()
  Select EventTimer()
    Case 1
      timer_event_1=1
    Case 2
      If stepp<stepp_1
        stepp+1
        go_x=stepp
        go_y=stepp
      EndIf
  EndSelect
EndProcedure

OpenWindow(0,0,0,win_x,win_y,"Break out - created by Werner Albus - www.nachtoptik.de - Quiet with ESC",#PB_Window_SystemMenu | #PB_Window_ScreenCentered)

If InitSprite() = 0 Or InitKeyboard() = 0 Or OpenWindowedScreen(WindowID(0),0,0,win_x,win_y,0,0,0,#PB_Screen_WaitSynchronization) = 0
  MessageRequester("Error", "Can not init Spritesystem",0)
  End
EndIf

AddWindowTimer(0,1,animation_speed) ; Handbrake for very quickly Computers:-)
AddWindowTimer(0,2,20) ; Accelerate Speed on Start

BindEvent(#PB_Event_Timer, @timer_events())

Dim clinker (clinker,1)

OpenWindowedScreen(WindowID(0),0,0,win_x,win_y)
ExamineKeyboard()
again:
; PlaySound(1) ; "Beep" Sound 1
For i=0 To 149
  CreateSprite(i,32,16)
  StartDrawing(SpriteOutput(i))
  FrontColor($00FF00)
  DrawingMode(#PB_2DDrawing_Gradient)
  LinearGradient (0,0,0,18)
  Box(0,0,32,8)
  FrontColor(0)
  BackColor($00FF00)
  Box(0,8,32,8)
  StopDrawing()
  RotateSprite(i,180,#PB_Absolute)
  clinker(i,0)=1 ; Clinkers on
Next i

CreateSprite(255,7,7)  ; Ball
CreateSprite(256,racket_width,7) ; Racket

StartDrawing(SpriteOutput(255))
Circle(3,3,3,$FFFFFF)
StopDrawing()

StartDrawing(SpriteOutput(256))
Box(0,0,racket_width,7,$FFFFFF)
StopDrawing()

ExamineMouse()
MouseLocate(win_x/2,win_y/2) ; Set Racket

Repeat 
  event=WaitWindowEvent(1)
  Select event
    Case #PB_Event_CloseWindow
      End
  EndSelect
  If timer_event_1
    timer_event_1=0
    FlipBuffers()
    ClearScreen(0)
    StartDrawing(ScreenOutput())
    DrawText(4,16,Str(count))
    StopDrawing()
    
    For i=5 To max_balls_1-15 Step 15
      DisplaySprite(255,i,7) ; Show available Balls
    Next i
    
    DisplaySprite(255,ball_x,ball_y) ; Show Ball
    
    clinker_1=0
    
    For ii=0 To 149 Step 30
      For i=4 To win_x Step 40
        
        ExamineMouse()
        mouse_x=MouseX()-racket_width>>1  ; - a half Racket width
        
        If SpriteCollision(256,Mouse_x,win_y-30,255,ball_x,ball_y)
          ; PlaySound(0) ; "Beep" Sound 0
          go_y=-stepp
          
          Select racket_moving
            Case 1 ; Racket moves to right
              If ball_x-mouse_x>racket_width>>1
                go_x=stepp
              Else
                go_x=stepp>>1
              EndIf
            Case -1 ; Racket moves to left
              If ball_x-mouse_x>racket_width>>1
                go_x=-stepp>>1
              Else
                go_x=-stepp
              EndIf
          EndSelect
        EndIf
        
        DisplaySprite(256,mouse_x,win_y-30) ; Show Racket
        
        If SpriteCollision(iii,i,50+ii,255,ball_x,ball_y)
          
          If clinker(iii,0)
            go_y=-go_y
            ; PlaySound(2) ; "Beep" Sound 2
            StartDrawing(SpriteOutput(iii))
            Select Point(0,8)
              Case  $008D00
                count+1
              Case  $007F7F
                count+2
              Case $7F5F00$
                count+3
              Case $00007F
                count+4
            EndSelect
            StopDrawing()
          EndIf
          
          If ball_x-i<17 ; 16 = a half clinker
            RotateSprite(iii,-10,#PB_Relative)
            clinker(iii,1)-10
          Else
            RotateSprite(iii,10,#PB_Relative)
            clinker(iii,1)+10
          EndIf
          
          If Abs(clinker(iii,1))>30  ; Tilting Angle max
            clinker(iii,0)=0
          Else
            StartDrawing(SpriteOutput(iii)) ; Re coloring Clinkers
            Select clinker(iii,1)
              Case 10,-10
                clinker_color=$00FFFF
              Case 20,-20
                clinker_color=$FFBF00
              Case 30,-30
                clinker_color=$0000FF
              Default
                clinker_color=$00FF00
            EndSelect
            FrontColor(clinker_color)
            DrawingMode(#PB_2DDrawing_Gradient)
            LinearGradient (0,0,0,16)
            Box(0,0,32,8)
            FrontColor(0)
            BackColor(clinker_color)
            Box(0,8,32,8)
            StopDrawing()
          EndIf
          
        EndIf
        
        If clinker(iii,0)
          clinker_1+1
          DisplaySprite(iii,i,50+ii) ; Show the Clinkers
        EndIf
        iii+1
        
      Next i
    Next ii
    
    If clinker_1<1 Or ball_y>win_y+25; Next Level and exit
      If ball_y>win_y+25
        max_balls_1-15
        If max_balls_1<15
          ; PlaySound(1) ; "Beep" Sound 1
          ReleaseMouse(1)
          If MessageRequester("Nochmal - again","Score : "+Str(count),#PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
            RunProgram(ProgramFilename())
          EndIf
          End
        EndIf
      EndIf
      iii=0
      ball_x=0
      ball_y=200
      stepp=0
      If clinker_1<1
        stepp_1+1 ; Next Level, add Speed
        If stepp_1>max_levels
          stepp_1=max_levels
        EndIf
        Goto again
      EndIf
    EndIf
    
    If iii>29 : iii=0 : EndIf
    
    ball_x+go_x : ball_y+go_y
    
    If Random(10)>9 ; breaking the symetric moving from the Ball
      ball_x+Random(1) : ball_y+Random(1)
    EndIf
    
    If ball_x>win_x-6 : go_x=-stepp : EndIf
    
    If ball_x<0 : go_x=stepp : EndIf
    
    If ball_y<0 : go_y=stepp : EndIf
    
    ExamineKeyboard()
    If KeyboardPushed(#PB_Key_Escape)
      End
    EndIf
    
    swapping=~swapping ; Analyse moving Racket
    If swapping
      moving_a=mouse_x
    Else
      moving_b=mouse_x
    EndIf
    If moving_a=moving_b
      racket_pos=mouse_x 
      racket_moving=0 ; Racket moves not
    EndIf
    If mouse_x>racket_pos
      racket_moving=1 ; Racket moves to right
    EndIf
    If mouse_x<racket_pos
      racket_moving=-1 ; Racket moves to left
    EndIf
  EndIf
  
ForEver
; IDE Options = PureBasic 5.21 LTS (Windows - x86)
; Folding = -
; EnableXP
; UseIcon = icon.ico
; Executable = Break_out_64bit.exe